searchNodes=[{"doc":"","ref":"Definject.html","title":"Definject","type":"module"},{"doc":"definject transforms a function to accept a map where dependent functions can be injected. import Definject definject send_welcome_email(user_id) do %{email: email} = Repo.get(User, user_id) Email.welcome(email) |&gt; Mailer.send() end is expanded into def send_welcome_email(user_id, deps \\\\ %{}) do %{email: email} = (deps[&amp;Repo.get/2] || &amp;Repo.get/2).(User, user_id) (deps[&amp;Email.welcome/1] || &amp;Email.welcome/1).(email) |&gt; (deps[&amp;Mailer.send/1] || &amp;Mailer.send/1).() end Then you can inject mock functions in tests. test &quot;send_welcome_email&quot; do Accounts.send_welcome_email(100, %{ &amp;Repo.get/2 =&gt; fn User, 100 -&gt; %User{email: &quot;mr.jechol@gmail.com&quot;} end, &amp;Mailer.send/1 =&gt; fn %Email{to: &quot;mr.jechol@gmail.com&quot;, subject: &quot;Welcome&quot;} -&gt; Process.send(self(), :email_sent) end }) assert_receive :email_sent end definject raises if the passed map includes a function that&#39;s not called within the injected function. You can disable this by adding strict: false option. test &quot;send_welcome_email with strict: false&quot; do Accounts.send_welcome_email(100, %{ &amp;Repo.get/2 =&gt; fn User, 100 -&gt; %User{email: &quot;mr.jechol@gmail.com&quot;} end, &amp;Repo.all/1 =&gt; fn _ -&gt; [%User{email: &quot;mr.jechol@gmail.com&quot;}] end, # Unused strict: false, }) end","ref":"Definject.html#definject/2","title":"Definject.definject/2","type":"macro"},{"doc":"If you don&#39;t need pattern matching in mock function, mock/1 can be used to reduce boilerplates. test &quot;send_welcome_email with mock/1&quot; do Accounts.send_welcome_email( 100, mock(%{ &amp;Repo.get/2 =&gt; %User{email: &quot;mr.jechol@gmail.com&quot;}, &amp;Mailer.send/1 =&gt; Process.send(self(), :email_sent) }) ) assert_receive :email_sent end Note that Process.send(self(), :email_sent) is surrounded by fn _ -&gt; end when expanded.","ref":"Definject.html#mock/1","title":"Definject.mock/1","type":"macro"},{"doc":"Definject Functional Dependency Injection in Elixir","ref":"readme.html","title":"Definject","type":"extras"},{"doc":"Existing mock libraries provide mocks at module level. While this approach works okay, it is somewhat rigid and cumbersome to use. Besides, functions are the basic building blocks of functional programming, not modules. Wouldn&#39;t it be nice to have a way to inject mocks at function level then? definject is an alternative way to inject mocks to each function. It grants a more fine-grained control over mocks, allowing you to provide different mocks to each function. It also does not limit using :async option as mocks are contained in each test function.","ref":"readme.html#why","title":"Definject - Why?","type":"extras"},{"doc":"The package can be installed by adding definject to your list of dependencies in mix.exs: def deps do [{:definject, &quot;~&gt; 0.3.3&quot;}] end","ref":"readme.html#installation","title":"Definject - Installation","type":"extras"},{"doc":"definject definject transforms a function to accept a map where dependent functions can be injected. import Definject definject send_welcome_email(user_id) do %{email: email} = Repo.get(User, user_id) Email.welcome(email) |&gt; Mailer.send() end is expanded into def send_welcome_email(user_id, deps \\\\ %{}) do %{email: email} = (deps[&amp;Repo.get/2] || &amp;Repo.get/2).(User, user_id) (deps[&amp;Email.welcome/1] || &amp;Email.welcome/1).(email) |&gt; (deps[&amp;Mailer.send/1] || &amp;Mailer.send/1).() end Then you can inject mock functions in tests. test &quot;send_welcome_email&quot; do Accounts.send_welcome_email(100, %{ &amp;Repo.get/2 =&gt; fn User, 100 -&gt; %User{email: &quot;mr.jechol@gmail.com&quot;} end, &amp;Mailer.send/1 =&gt; fn %Email{to: &quot;mr.jechol@gmail.com&quot;, subject: &quot;Welcome&quot;} -&gt; Process.send(self(), :email_sent) end }) assert_receive :email_sent end definject raises if the passed map includes a function that&#39;s not called within the injected function. You can disable this by adding strict: false option. test &quot;send_welcome_email with strict: false&quot; do Accounts.send_welcome_email(100, %{ &amp;Repo.get/2 =&gt; fn User, 100 -&gt; %User{email: &quot;mr.jechol@gmail.com&quot;} end, &amp;Repo.all/1 =&gt; fn _ -&gt; [%User{email: &quot;mr.jechol@gmail.com&quot;}] end, # Unused strict: false, }) end mock If you don&#39;t need pattern matching in mock function, mock/1 can be used to reduce boilerplates. test &quot;send_welcome_email with mock/1&quot; do Accounts.send_welcome_email( 100, mock(%{ &amp;Repo.get/2 =&gt; %User{email: &quot;mr.jechol@gmail.com&quot;}, &amp;Mailer.send/1 =&gt; Process.send(self(), :email_sent) }) ) assert_receive :email_sent end Note that Process.send(self(), :email_sent) is surrounded by fn _ -&gt; end when expanded.","ref":"readme.html#usage","title":"Definject - Usage","type":"extras"},{"doc":"This project is licensed under the MIT License - see the LICENSE.md file for details","ref":"readme.html#license","title":"Definject - License","type":"extras"}]